import greenfoot.*;
import java.util.*;

/**
 * The HealthCollection class handles the collection of Health objects.
 * This allows us to add and remove health as we see fit.
 * 
 * @author Revernd 
 * @version 20120109
 */
public class HealthCollection  
{
    private ArrayList<Health> theHealth;
    private static final int TOTAL_LIVES = 3;
    private World road;

    /**
     * Constructor for objects of class HealthCollection
     */
    public HealthCollection(World road)
    {
        this.theHealth = new ArrayList<Health>();
        this.road = road;
        
        for (int i = 0; i < TOTAL_LIVES; i++)
        {
            this.theHealth.add( new Health() );
        }
        
        this.drawHealth();
    }
    
    public void removeHealth()
    {
        Health health = this.theHealth.get(this.theHealth.size() - 1);
        this.theHealth.remove(health);
        this.road.removeObject(health);
        this.drawHealth();
    }
    
    public void addHealth()
    {
        this.theHealth.add( new Health() );
        this.drawHealth();
    }
    
    public int getHealth()
    {
        return this.theHealth.size();
    }
    
    private void drawHealth()
    {
        int step = 20;
        for (Health obj : theHealth)
        {
            road.addObject(obj, step, 580);
            step += 25;
        }
    }

}
