import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * This class sets us up with the road object.
 * 
 * @author Revernd 
 * @version 20120107
 */
public class Road extends World
{

    private Counter bodiesSaved;
    private Counter gameScore;
    private Car theCar;

    /**
     * Constructor for objects of class Road.
     */
    public Road()
    {    
        super(800, 600, 1); 

        bodiesSaved = new Counter("Saved: 0");
        gameScore = new Counter("Score: 0");

        addObject(bodiesSaved, 65, 20);
        addObject(gameScore, 732, 20);

        theCar = new Car(this);
        addObject(theCar, 400, 520);

        prepare(); // Auto generated when right click and save world
    }

    public Counter getBodiesSaved()
    {
        return bodiesSaved;
    }

    public Counter getScore()
    {
        return gameScore;
    }

    public void act()
    {
        if (Greenfoot.getRandomNumber(300) < 5) {
            int rX = Greenfoot.getRandomNumber(this.getWidth());
            int rY = Greenfoot.getRandomNumber(this.getHeight());
            addObject(new Person(), rX, rY);
        }
        if (Greenfoot.getRandomNumber(1000) < 3)
        {
            int rX = Greenfoot.getRandomNumber(this.getWidth());
            int rY = Greenfoot.getRandomNumber(this.getHeight());
            List<Car> cars = this.getObjectsAt(rX, rY, Car.class);
            if ( cars != null ) addObject(new Enemy(), rX, rY);
        }
        if (Greenfoot.getRandomNumber(7000) < 2)
        {
            List<Bonus> bonus = this.getObjects(Bonus.class);
            this.removeObjects(bonus);
        }
        if (Greenfoot.getRandomNumber(5000) < 3)
        {
            int rX = Greenfoot.getRandomNumber(this.getWidth());
            int rY = Greenfoot.getRandomNumber(this.getHeight());
            this.addObject(new Bonus(), rX, rY);
        }

    }

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        Enemy enemy = new Enemy();
        addObject(enemy, 327, 504);
        Person person = new Person();
        addObject(person, 363, 542);
        removeObject(person);
        Person person2 = new Person();
        addObject(person2, 364, 539);
        person2.setLocation(360, 532);
        person2.setLocation(360, 525);
        person2.setLocation(357, 535);
        removeObject(person2);
        removeObject(enemy);
    }
}
